#include "HOG.h"

//zxƌz̎Zo
void CompMagnitudeAndGrad( int x, int y, IplImage *img, double *magnitude, double *grad)
{
	int width, height;
	int wStep, bpp;
	double xgrad, ygrad;
	double angle;

	width = img->width;
	height = img->height;
	wStep = img->widthStep;
	bpp   = ((img->depth & 255) / 8) * img->nChannels;
	
	unsigned char* imgSource = (unsigned char*) img->imageData;

	//̍
	if(x == 0){
		xgrad = imgSource[y*wStep+(x+0)*bpp] - imgSource[y*wStep+(x+1)*bpp];
	}else if(x == width-1){
		xgrad = imgSource[y*wStep+(x-1)*bpp] - imgSource[y*wStep+(x+0)*bpp];
	}else{
		xgrad = imgSource[y*wStep+(x-1)*bpp] - imgSource[y*wStep+(x+1)*bpp];						
	}

	//c̍
	if(y == 0){
		ygrad = imgSource[(y+0)*wStep+x*bpp] - imgSource[(y+1)*wStep+x*bpp];
	}else if(y == height-1){
		ygrad = imgSource[(y-1)*wStep+x*bpp] - imgSource[(y+0)*wStep+x*bpp];
	}else{
		ygrad = imgSource[(y-1)*wStep+x*bpp] - imgSource[(y+1)*wStep+x*bpp];
	}

	//zx̎Zo
	*magnitude = sqrt( xgrad*xgrad + ygrad*ygrad );

	//z̎Zo
	*grad = atan2( ygrad, xgrad );
	//WApx֕ϊ
	*grad  = (*grad * 180) / PI;
	//łꍇ͔]
	if( *grad<0.0){
		*grad += 360.0;
	}
	//0`360x0`180xɕϊ
	if( *grad>180.0){
		*grad -= 180.0;
	}

	//1̊pxZo
	angle = 180.0 / ORIENTATION;
	//zŊpx𕪊
	*grad = *grad / angle;
}

//zqXgO̎Zo
void CompHistogram( double cell_hist[], IplImage *img )
{
	int    x, y;
	double grad, magnitude;

	//pb`̈ړ
	for(y=0; y<HEIGHT; y++){
		for(x=0; x<WIDTH; x++){

			//zxƌz̎Zo
			CompMagnitudeAndGrad( x, y, img, &magnitude, &grad);

			//qXgOɒ~
			cell_hist[ (y/CELL)*(WIDTH/CELL)*ORIENTATION + (x/CELL)*ORIENTATION + (int)grad] += magnitude;
		}
	}
}

//ʂ̎Zo
void CompHOG( vector<double> &hog, double cell_hist[] )
{
	int	i,j,k,x,y;

	double sum_magnitude;
	double tmp = 0.0;
	double f;

	//ubN̈ړ
	for(y=0; y<((HEIGHT/CELL)-BLOCK+1); y++){
		for(x=0; x<((WIDTH/CELL)-BLOCK+1); x++){	

			sum_magnitude = 0.0;
			//Z̈ړ
			for(j=0; j<BLOCK; j++){
				for(i=0; i<BLOCK; i++){
					//z
					for(k=0; k<ORIENTATION; k++){
						//K̂߃qXgȎa̓Zo
						tmp = cell_hist[(y+j)*(WIDTH/CELL)*ORIENTATION + (x+i)*ORIENTATION + k];
						sum_magnitude += tmp * tmp;
					}
				}
			}

			sum_magnitude = 1.0 / sqrt(sum_magnitude + LN_E);
			
			//Z̈ړ
			for(j=0; j<BLOCK; j++){
				for(i=0; i<BLOCK; i++){
					//z
					for(k=0; k<ORIENTATION; k++){
						//ʒo
						f = cell_hist[(y+j)*(WIDTH/CELL)*ORIENTATION + (x+i)*ORIENTATION + k] * sum_magnitude;
						hog.push_back(f);
					}
				}
			}
		}
	}
}

//HOGʂ̒o
void HOG( vector<double> &hog, IplImage *img )
{
	int    i,j,k;
	double *cell_hist;
	cell_hist = new double[ (HEIGHT/CELL) * (WIDTH/CELL) * ORIENTATION];

	//0ď
	for(j=0; j<(HEIGHT/CELL); j++){
		for(i=0; i<(WIDTH/CELL); i++){
			for(k=0; k<ORIENTATION; k++){
				cell_hist[ j*(WIDTH/CELL)*ORIENTATION + i*ORIENTATION + k] = 0.0;
			}
		}
	}

	//zqXgO̎Zo
	CompHistogram( cell_hist, img );

	//ʂ̎Zo
	CompHOG( hog, cell_hist );

	delete []cell_hist;
}


