#include "RealAdaBoost.h"
#include "common.h"

//
int Initialization(vector<Sample> &samples, int iSampleNum[]){
	int i;
	
	//wKTv̏d݂
	for(i = 0; i < (int)samples.size(); i++){
		if(samples[i].label == POS){
			samples[i].weight = (1.0 / (iSampleNum[POS] * 2.0));
		}else{
			samples[i].weight = (1.0 / (iSampleNum[NEG] * 2.0));
		}
	}

	return 0;
}

//mx֐̏
int ClearPDF(double pdf[][2]){
	int i, j;
	
	for(i = 0; i < BIN; i++){
		for(j = 0; j < 2; j++){
			pdf[i][j] = 0.0;
		}
	}

	return 0;
}

//mxzZo
int CompPDF(vector<Sample> &samples, double dPdf[][2], int iFeatureNum){
	int i;
	int tmp;
	double dFeature;
	double dSumPos, dSumNeg;
	dSumPos = dSumNeg = 0.0;

	//mx֐̏
	ClearPDF(dPdf);

	for(i = 0; i < (int)samples.size(); i++){
		dFeature = samples[i].hog[iFeatureNum];

		//[0, 1]͈̔͂łʂBIN̑傫ɗʎq
		tmp = (int)(dFeature * BIN);

		//ʂ[0, 1]͈̔͂ɂȂꍇ̏
		if(tmp < 0){
			tmp = 0;
		}
		if(tmp >= BIN){
			tmp = BIN - 1;
		}

		//wKTv̏d݂Z
		dPdf[tmp][samples[i].label] += samples[i].weight;
	}

	//NX̏d݂̑aZo
	for(i = 0; i < BIN; i++){
		dSumPos += dPdf[i][POS];
		dSumNeg += dPdf[i][NEG];
	}

	//NX̏d݂pĐK
	for(i = 0; i < BIN; i++){
		dPdf[i][POS] = dPdf[i][POS] / dSumPos;
		dPdf[i][NEG] = dPdf[i][NEG] / dSumNeg;
	}

	return 0;
}


//2NX̊mx֐BhattacharyaZo
double EvalPDF(double dPdf[][2]){
	int i;
	double w;
	double z = 0;

	for(i = 0; i < BIN; i++){
		w = dPdf[i][POS] * dPdf[i][NEG];
		z += sqrt(w);
	}

	return z;
}

//㎯ʊ̑I
int SelectClassifier(vector<Sample> &samples, WeakClassifier *cl, double dPdf[][2]){
	double dminerror = 1000.0;
	double z;
	int i;
	int iFeatureNum;

	for(i = 0; i < (int)samples[0].hog.size(); i++){
		//mx֐̍쐬
		CompPDF(samples, dPdf, i);
		//㎯ʊ̕]lZo
		z = EvalPDF(dPdf);

		//S㎯ʊ̒G[łႢ㎯ʊI
		if(dminerror > z){
			dminerror = z;
			iFeatureNum = i;
		}
	}

	//G[łႢ㎯ʊ̕]lƎ㎯ʊԍ̕ۑ
	cl->z = dminerror;
	cl->iFeatureNum = iFeatureNum;

	//Iꂽ㎯ʊpĊmx֐쐬
	CompPDF(samples, dPdf, iFeatureNum);

	return 0;
}

//㎯ʊ̏o͂Zo
double Prediction(double dFeature, double dPdf[][2], double dEpsilon){
	int tmp;
	double h;

	//ʂʎq
	tmp = (int)(dFeature * BIN);
	if(tmp < 0){
		tmp = 0;
	}
	if(tmp >= BIN){
		tmp = BIN - 1;
	}

	//㎯ʊ̏o͂Zo
	h = 0.5 * log((dPdf[tmp][POS] + dEpsilon)/(dPdf[tmp][NEG] + dEpsilon));

	return h;
}

//wKTv̏d݂XV
int	UpdateSampleWeight(vector<Sample> &samples, double dPdf[][2], int iFeatureNum, double dEpsilon){
	double dSumWeight = 0.0;
	double dConfidence;
	int i;

	for(i = 0; i < (int)samples.size(); i++){
		//㎯ʊ̏o͂Zo
		dConfidence = Prediction(samples[i].hog[iFeatureNum], dPdf, dEpsilon);

		//㎯ʊ̏o͂pĊwKTv̏d݂XV
		if(samples[i].label == POS){
			samples[i].weight = samples[i].weight * exp(-dConfidence);
		}else{
			samples[i].weight = samples[i].weight * exp(dConfidence);
		}	

		//d݂ݐςAd݂̑aZo
		dSumWeight += samples[i].weight;
	}

	//Tv̏d݂̑a1ƂȂ悤ɐK
	for(i = 0; i < (int)samples.size(); i++){
		samples[i].weight = samples[i].weight / dSumWeight;
	}

	return 0;
}

//mx֐̏o
int WritePDF(double dPdf[][2], int iRound){
	int i;
	FILE *fp;
	char fname[256];

	sprintf(fname, "%s%d.txt", DIR_PDF, iRound);
	if((fp = fopen(fname,"w")) == NULL){
		printf("Can Not open PDF file \n");
		exit(1);
	}

	for(i = 0 ; i < BIN ; i++){
		fprintf(fp,"%lf %lf\n", dPdf[i][POS], dPdf[i][NEG]);
	}

	fclose(fp);
	return 0;
}

//wKf[^̏o
int WriteWeakClassifier(WeakClassifier *cl){
	FILE *fp;
	char fname[256];

	sprintf(fname, "%s", DIR_WEAK_CLASSIFIER);
	if(( fp = fopen(fname,"a")) == NULL){
		printf("Can not open training data file.\n");
		exit(1);
	}

	fprintf(fp, "%d %lf\n", cl->iFeatureNum, cl->z);

	fclose(fp);
	return 0;
}

//ʂɕKvȃp[^̏o
int WriteParameter(double dEpsilon){
	FILE *fp;
	char fname[256];

	sprintf(fname, "%s", DIR_WEAK_CLASSIFIER);
	if(( fp = fopen(fname,"w")) == NULL){
		printf("Can not open training data file.\n");
		exit(1);
	}

	fprintf(fp, "%lf\n", dEpsilon);

	fclose(fp);

	return 0;
}

//RealAdaBoostɂ鎯ʊ̊wK
int Training(vector<Sample> &samples, int iSampleNum[]){
	int iRound;
	double dEpsilon;
	double dPdf[BIN][2];
	WeakClassifier	*cl;

	//Zs\hW̎ZoAt@Cɏo
	dEpsilon = 1.0 / (iSampleNum[POS] + iSampleNum[NEG]);
	WriteParameter(dEpsilon);

	cl = new WeakClassifier[MAX_WEAK_CLASSIFIER];

	//wKTv̏d݂
	Initialization(samples, iSampleNum);

	//wK
	for(iRound = 0; iRound < MAX_WEAK_CLASSIFIER; iRound++){
		printf("Number of weak classifiers : %d\r",iRound + 1);

		//㎯ʊ̒łG[㎯ʊI
		SelectClassifier(samples, cl, dPdf);

		//wKTv̏d݂XV
		UpdateSampleWeight(samples, dPdf, cl->iFeatureNum, dEpsilon);

		//mx֐o
		WritePDF(dPdf, iRound);

		//wKf[^(㎯ʊ)o
		WriteWeakClassifier(cl);

	}

	delete cl;
	return 0;
}

